local tilesetImage
local placedx = 10
local placedy = 10
local camerax = 0
local cameray = 0
local brush = 0

function love.load()
	loadMap()

end

function loadMap()

	mapWidth = 20
	mapHeight = 20
	
	map = {}
	for x=0,mapWidth-1 do
		map[x] = {}
	end
		
		
	
	--load map
	
	love.filesystem.load("map/map.lua")()

	--convert tileset into quads
    tilesetImage = love.graphics.newImage( "tileset/tileset.png" )
  tilesetImage:setFilter("nearest", "linear") -- this "linear filter" removes some artifacts if we were to scale the tiles
  tileSize = 16
     tile = {}
	maxtiles = 0
	for y=0,tilesetImage:getHeight()/tileSize-1 do
		for x=0,tilesetImage:getWidth()/tileSize-1 do
			tile[maxtiles] = love.graphics.newQuad(x * tileSize, y * tileSize, tileSize, tileSize,
			tilesetImage:getWidth(), tilesetImage:getHeight())
			maxtiles = maxtiles + 1
		end
	end
	
end

function love.draw()
	

	
	love.graphics.translate(camerax, cameray)

    local mousex, mousey = love.mouse.getPosition()
	mousex = mousex - camerax
	mousey = mousey - cameray
	
	tilex = math.modf(mousex/16)
	tiley = math.modf(mousey/16)

  for x=0,mapWidth-1 do
    for y=0,mapHeight-1 do
		for b=0,maxtiles do
			if map[x][y] == b then
				love.graphics.drawq(tilesetImage, tile[b], x*16, y*16)
			end	
		end
    end
  end
  if tilex < mapWidth and tiley < mapHeight and tilex >= 0 and tiley >= 0 then
	love.graphics.drawq(tilesetImage, tile[brush], tilex*16, tiley*16)
	end
	
	--Print information
	love.graphics.print("Camera Location (x,y):"..-camerax..", "..-cameray, -camerax + 10, -cameray + 10)
	love.graphics.print("Tile: "..brush, -camerax + 10, -cameray + 20)
		
end

function love.update()
	if love.keyboard.isDown( "q" ) then
      love.event.push('q')
   end
end

function love.keypressed(key)
	if key == "b" then
		brush = brush + 1
		if brush == maxtiles then
			brush = 0
		end
	end
	if key == "v" then
		brush = brush - 1
		if brush < 0 then
			brush = maxtiles - 1
		end
   end
   if key == "d" then
		camerax = camerax - 8
   end
   if key == "a" then
		camerax = camerax + 8
   end
   if key == "w" then
		cameray = cameray + 8
   end
   if key == "s" then
		cameray = cameray - 8
   end
   if key == "e" then
       local strg = "map = {\n" -- starting the string buffer

          for x = 1, #map do
               strg = strg .. "\t{ "        -- add to beginning of row the bracket
                  for y = 1, #map[1] do
                  strg = strg .. tostring(map[x][y]) -- add the map value to string
                  if y < #map[1] then strg = strg .. ", " end -- add comma unless it's the last value of map row
                  end
                  strg = strg .. " },\n" -- end of map row bracket
            end
       strg = strg .. " \n}" -- end of map table bracket
            
       love.filesystem.newFile( "map/map2.lua" )
       love.filesystem.write( "map/map2.lua", strg ) -- write the final string to file
	end

end

function love.mousepressed(x, y, button)
   if button == "l" then
		y = y - cameray
		x = x - camerax
      placedx = math.modf(x/16)
      placedy = math.modf(y/16)
	  if placedx < mapWidth and placedy < mapHeight and placedx >= 0 and placedy >= 0 then
	  map[placedx][placedy] = brush
	  end
   end
end